/**
 * Created by AlexanderC on 9/23/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DBServer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _LocalDynamo = require('./Driver/LocalDynamo');

var _Dynalite = require('./Driver/Dynalite');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

let DBServer = exports.DBServer = function () {
  function DBServer() {
    _classCallCheck(this, DBServer);
  }

  _createClass(DBServer, null, [{
    key: 'create',

    /**
     * @param {Function|String} driver
     * @param {*} args
     * @returns {Function}
     */
    value: function create() {
      let driver = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DBServer.DEFAULT_DRIVER;

      let DriverProto = typeof driver === 'string' ? DBServer._findDriverPrototype(driver) : driver;

      if (!DriverProto) {
        throw new Error(`Missing DB server driver ${driver}`);
      }

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      return new (Function.prototype.bind.apply(DriverProto, [null].concat(args)))();
    }

    /**
     * @param {String} name
     * @returns {Function}
     * @private
     */

  }, {
    key: '_findDriverPrototype',
    value: function _findDriverPrototype(name) {
      for (let driverProtoKey in DBServer.DRIVERS) {
        if (!DBServer.DRIVERS.hasOwnProperty(driverProtoKey)) {
          continue;
        }

        let driverProto = DBServer.DRIVERS[driverProtoKey];

        if (driverProto.name === name) {
          return driverProto;
        }
      }

      return null;
    }

    /**
     * @returns {Function[]}
     */

  }, {
    key: 'DRIVERS',
    get: function get() {
      return [_LocalDynamo.LocalDynamo, _Dynalite.Dynalite];
    }

    /**
     * @returns {Function}
     */

  }, {
    key: 'DEFAULT_DRIVER',
    get: function get() {
      return DBServer.DRIVERS[0];
    }
  }]);

  return DBServer;
}();