/**
 * Created by AlexanderC on 9/23/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dynalite = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _PathAwareDriver2 = require('./PathAwareDriver');

var _dynalite = require('dynalite');

var _dynalite2 = _interopRequireDefault(_dynalite);

var _FailedToStartServerException = require('./Exception/FailedToStartServerException');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let Dynalite = exports.Dynalite = function (_PathAwareDriver) {
  _inherits(Dynalite, _PathAwareDriver);

  /**
   * @param {Object} options
   * @param {String} path
   * @param {Number} port
   */
  function Dynalite() {
    let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Dynalite.DEFAULT_OPTIONS;
    let path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Dynalite.DBPath;
    let port = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Dynalite.DEFAULT_PORT;

    _classCallCheck(this, Dynalite);

    var _this = _possibleConstructorReturn(this, (Dynalite.__proto__ || Object.getPrototypeOf(Dynalite)).call(this, path, port));

    _this._options = options;
    _this._server = null;
    return _this;
  }

  /**
   * @returns {Object}
   */


  _createClass(Dynalite, [{
    key: '_start',


    /**
     * @param {Function} cb
     * @private
     */
    value: function _start(cb) {
      this._options.path = this.path;

      this._server = (0, _dynalite2.default)(this._options);

      this._server.listen(this.port, error => {
        if (error) {
          cb(new _FailedToStartServerException.FailedToStartServerException(this, error));
          return;
        }

        cb(null);
      });
    }

    /**
     * @param {Function} cb
     * @private
     */

  }, {
    key: '_stop',
    value: function _stop(cb) {
      if (this._server) {
        this._server.close(cb);
        this._server = null;

        return;
      }

      cb(null);
    }

    /**
     * @returns {Object}
     */

  }, {
    key: 'options',
    get: function get() {
      return this._options;
    }
  }], [{
    key: 'DEFAULT_OPTIONS',
    get: function get() {
      return {
        createTableMs: 0,
        deleteTableMs: 0,
        updateTableMs: 0
      };
    }
  }]);

  return Dynalite;
}(_PathAwareDriver2.PathAwareDriver);