/**
 * Created by AlexanderC on 9/23/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PathAwareDriver = undefined;

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _AbstractDriver = require('./AbstractDriver');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class PathAwareDriver extends _AbstractDriver.AbstractDriver {
  /**
   * @param {String} path
   * @param {Number} port
   */
  constructor(path = PathAwareDriver.DBPath, port = PathAwareDriver.DEFAULT_PORT) {
    super(port);

    this._path = path;
  }

  /**
   * @returns {String}
   */
  get path() {
    return this._path;
  }

  /**
   * @param {String} path
   */
  set path(path) {
    this._path = path;
  }

  /**
   * @returns {String}
   */
  static get DBPath() {
    let dir = _path2.default.join(_os2.default.tmpdir(), this.name);

    // @todo: do it async!
    if (!_fs2.default.existsSync(dir)) {
      _fs2.default.mkdirSync(dir);
    }

    return dir;
  }
}
exports.PathAwareDriver = PathAwareDriver;