/**
 * Created by Stefan Hariton on 6/26/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InvalidArgumentException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when invalid argument provided
 */
class InvalidArgumentException extends _Exception.Exception {
  /**
   * @param {*} argument
   * @param {String} meantType
   */
  constructor(argument, meantType) {
    let argumentType = typeof argument;

    super(`Invalid argument ${argument} of type ${argumentType} provided (meant ${meantType}).`);
  }
}
exports.InvalidArgumentException = InvalidArgumentException;