/**
 * Created by Stefan Hariton on 6/26/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UndefinedMethodException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when undefined method is requested
 */
class UndefinedMethodException extends _Exception.Exception {
  /**
   * @param {String} name
   * @param {String[]} availableMethods
   */
  constructor(name, availableMethods) {
    super(`Method: ${name} does not exist. Available methods:${availableMethods}).`);
  }
}
exports.UndefinedMethodException = UndefinedMethodException;